/*============================================================================
  Summary:  Demonstrates how Shared-Locks are also held till the end
			of the statement in Read Committed
------------------------------------------------------------------------------
  Written by Klaus Aschenbrenner, SQLpassion.at

  For more scripts and sample code, check out 
    http://www.SQLpassion.at
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

-- Create a new database
CREATE DATABASE ReadCommittedLOB
GO

-- Use it
USE ReadCommittedLOB
GO

-- Create a new table
CREATE TABLE TestTable
(
	ID INT IDENTITY(1, 1) NOT NULL PRIMARY KEY,
	Col2 INT,
	Col3 VARCHAR(MAX)
)
GO

-- Insert some records into the table
INSERT INTO TestTable VALUES (1, 'abc'), (2, 'def'), (3, 'ghi')
GO

-- Retrieve the inserted data
SELECT * FROM TestTable
GO

-- Begin a new transaction, so that we are blocking some records in the table
BEGIN TRANSACTION

UPDATE TestTable SET Col2 = 1 WHERE ID = 3

--ROLLBACK