/*============================================================================
  Summary:  Demonstrates how Shared-Locks are also held till the end
			of the statement in Read Committed
------------------------------------------------------------------------------
  Written by Klaus Aschenbrenner, SQLpassion.at

  For more scripts and sample code, check out 
    http://www.SQLpassion.at
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

USE ReadCommittedLOB
GO

-- This statement only acquires a key lock on the current record
SELECT Col2 FROM TestTable
ORDER BY Col2
GO

-- This statement acquires a key lock on *every record* is is not releasing those locks
SELECT Col3 FROM TestTable
ORDER BY Col2
GO

-- This statement acquires a key lock on *every record* is is not releasing those locks
SELECT Col2 FROM TestTable
WHERE Col3 IS NOT NULL
GO

-- Retrieve the acquires locks in a different session through the following statement
SELECT * FROM sys.dm_tran_locks
WHERE request_session_id = @@spid
GO