USE master
GO

CREATE DATABASE ThreadPoolWaits
GO

USE ThreadPoolWaits
GO

-- Create a new test table (this one will be unique on earth - hopefully...)
CREATE TABLE MyTable
(
	Col1 INT IDENTITY(1, 1) NOT NULL PRIMARY KEY,
	Col2 INT
)
GO

-- Insert a record
INSERT INTO MyTable VALUES (1)
GO

-- Create a stored procedure that encapsulates a read workload
CREATE PROCEDURE ReadWorkload
AS
BEGIN
	SELECT * FROM MyTable
END
GO

-- Begin a transaction that never commits...
BEGIN TRANSACTION
	UPDATE MyTable WITH (TABLOCKX)
		SET Col2 = 2
GO

-- Configuration option "max worker threads"
sp_configure 'max worker threads'
GO

-- Number of currently used worker threads
SELECT max_workers_count FROM sys.dm_os_sys_info
GO

-- Run the read workload with a higher number than the maximum worker thread setting
-- ostress.exe -Q"EXEC ThreadPoolWaits.dbo.ReadWorkload" -n600